



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>获取Django项目的全部url</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">获取Django项目的全部url</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-02 17:45:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在为一个项目添加权限时，遇到一个问题，就是为项目所有的url设置权限，但是一个一个手动输入太麻烦了，所以考虑用代码获取到一个项目所有的url</p>
<p>首先，考虑到项目最外层的urlpartterns，因为所有的url都要通过这里</p>
<div>
<pre class="prettyprint linenums">urlpatterns = [<br />
    # url(r'^admin/', admin.site.urls),<br />
    url(r'^arya/', site.urls),<br />
    url(r'^index/', index),<br />
]</pre>
</div>
<p>先循环打印一下这个列表，看一下拿到的结果：</p>
<div>
<pre class="prettyprint linenums">&lt;RegexURLResolver &lt;RegexURLPattern list&gt; (arya:arya) ^arya/&gt;<br />
&lt;RegexURLResolver &lt;module 'rbac.urls' from 'C:\\Users\\zhangcan\\Desktop\\pro_crm\\pro_crm\\rbac\\urls.py'&gt; (None:None) ^rbac/&gt;<br />
&lt;RegexURLPattern None ^index/&gt;</pre>
</div>
<p>可以看到，直接有对应函数的和通过文件导入的这种嵌套的，打印出来的类型是不一样的，导入一下这个类型</p>
<div>
<pre class="prettyprint linenums">from django.urls.resolvers import RegexURLPattern<br />
from django.urls.resolvers import RegexURLResolver</pre>
</div>
<p>按住ctrl点进去看一下源码，找来找去看到有个</p>
<div>
<pre class="prettyprint linenums">self._regex = regex</pre>
</div>
<p>拿到代码中打印一下这个，拿到：</p>
<div>
<pre class="prettyprint linenums">^arya/<br />
^rbac/<br />
^index/</pre>
</div>
<p>哇，妙啊，但是这个只能是最后一个有用，上面两个还有嵌套，我们通过上面拿到的两种类型区分一下</p>
<p>对于这种有嵌套的，可以使用递归来一层一层的扒开它，直到拿到的是 &nbsp;RegexURLPattern &nbsp;类型</p>
<p>而且，每扒开一层，它的url得加上之前的那个</p>
<p>我们可以通过 &nbsp;&nbsp;item.urlconf_name &nbsp; 拿到嵌套的里面一层的urlpartterns</p>
<p>这里面还涉及一个问题就是，用递归函数的话，如何保存每次得到的结果?</p>
<p>可以用一个全局变量，没有问题，其实还可以用一个Python的特性，就是如果参数的默认值为字典，列表这种可变数据类型的话，以后引用的都是同一个内存地址</p>
<p>所以这个全局变量还可以写成是一个默认是个空列表的参数,但是这样又出了新的问题，就是只要不重启项目，这个列表一直不清空，所以再用一个默认参数为False，第一次调用的时候把这个参数设置为True，在函数中判断如果这个参数为True，就清空列表。</p>
<p>最终代码可以写成这样：</p>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url,include<br />
from arya.service.sites import site

from django.urls.resolvers import RegexURLPattern<br />
from django.urls.resolvers import RegexURLResolver

from django.shortcuts import HttpResponse

def index(request):<br />
    print(get_all_url(urlpatterns,prev='/'))<br />
    return HttpResponse('...')<br />
def get_all_url(urlparrentens,prev,is_first=False,result=[]):<br />
    if is_first:<br />
        result.clear()<br />
    for item in urlparrentens:<br />
        v = item._regex.strip('^$')#去掉url中的^和$<br />
        if isinstance(item,RegexURLPattern):<br />
            result.append(prev + v)<br />
        else:<br />
            get_all_url(item.urlconf_name,prev + v)<br />
    return result

urlpatterns = [<br />
    url(r'^arya/', site.urls),<br />
    url(r'^index/', index),<br />
]</pre>
</div>
<p>这样就拿到了这个项目所有的url</p>
<div>
<pre class="prettyprint linenums">['/arya/login/', '/arya/logout/', '/arya/app01/department/', '/arya/app01/department/add/', '/arya/app01/department/(.+)/delete/', '/arya/app01/department/(.+)/change/', '/arya/app01/userinfo/', '/arya/app01/userinfo/add/', '/arya/app01/userinfo/(.+)/delete/', '/arya/app01/userinfo/(.+)/change/', '/arya/rbac/userinfo/', '/arya/rbac/userinfo/add/', '/arya/rbac/userinfo/(.+)/delete/', '/arya/rbac/userinfo/(.+)/change/', '/arya/rbac/role/', '/arya/rbac/role/add/', '/arya/rbac/role/(.+)/delete/', '/arya/rbac/role/(.+)/change/', '/arya/rbac/permission/', '/arya/rbac/permission/add/', '/arya/rbac/permission/(.+)/delete/', '/arya/rbac/permission/(.+)/change/', '/arya/rbac/menu/', '/arya/rbac/menu/add/', '/arya/rbac/menu/(.+)/delete/', '/arya/rbac/menu/(.+)/change/', '/index/']</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw524kq.html">【转】SVN添加文件时的错误处理：&period;&period;&period;&bsol;conf&bsol;svnserve&period;conf&colon;12&colon; Option expected</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2lyk8.html">Collection类相关总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2o00o9.html">Qt&mdash;&mdash;QLineEdit使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyddnldq.html">&lpar;28&rpar;odoo中css可用颜色对照表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jp5g8.html">Android Studio 常用快捷键以及设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvk06xq.html">bzoj 1458 士兵占领（最大流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4wmr9.html">SQLSERVER一个比较不错的分页存储过程p&lowbar;splitpage</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5121q.html">css中同时用头部引入和外部引入对同一个标签进行样式设置，哪一个优先级高。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6o6w8.html">Java 控制台输入数字 输出乘法表（代码练习）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpzmj8.html">&lbrack;PHP&rsqb; 频率限制类</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rvjvm9.html">keras图像风格迁移</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvg4vx8.html">利用教育邮箱注册JetBrains产品&lpar;pycharm、idea等&rpar;的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjkx069.html">&lbrack;转&rsqb;jvm调优-命令大全（jps jstat jmap jhat jstack jinfo）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kgvy9.html">jQuery中【width&lpar;&rpar;&comma;innerWidth&lpar;&rpar;&comma;outerWidth&lpar;&rpar;】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ey5wq.html">AngularJS中获取数据源的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wmv4nq.html">Hbase物理模型设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1zpveq.html">Karma - MVC Framework for Unity3D</a>
		</li>
						<li><a href="https://www.batexi.com/a/953wwe08.html">VB6 创建控制台应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ew3w19.html">vsftp添加用户及测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp43y79.html">Laravel 完整开源项目大全</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qljw7e69.html">JAVA课程设计个人博客 学生成绩管理 201521145048 林健</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ky2g49.html">201521123101 《Java程序设计》第9周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy16lvdq.html">JQUERY选中问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jgegw8.html">AJAX验证码检查</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gez6o78.html">Oracle&lowbar;Sequence如何初始化开始值</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg6ped8.html">Java 删除项目中的&period;svn信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljw0m09.html">Activiti常见问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y31dw8.html">高德地图markers生成和点击</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m45ej8.html">监控-CPU使用率</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg6lkm8.html">Linux下安全证书申请以及配置到Nginx</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
